=== modules/extra/stats/irc2sql/CMakeLists.txt ===
build_subdir(${CMAKE_CURRENT_SOURCE_DIR})
