=== debian/changelog ===
anope (2.0.17-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Backport upstream fixes for FTBFS with CMake 4. (Closes: #1112699)

 -- Adrian Bunk <bunk@debian.org>  Sat, 11 Oct 2025 13:45:08 +0300

anope (2.0.17-1) unstable; urgency=medium

  * New upstream release (Closes: #1089533)
    - update default configs from examples
  * Update Standards-Version (no changes)

 -- Dominic Hargreaves <dom@earth.li>  Mon, 24 Mar 2025 21:58:25 +0000
