=== debian/control ===
Source: anope
Section: net
Priority: optional
Maintainer: Dominic Hargreaves <dom@earth.li>
Build-Depends: debhelper-compat (= 13),
 cmake,
 default-libmysqlclient-dev,
 libldap2-dev,
 libpcre2-dev,
 libgnutls28-dev,
 libsqlite3-dev,
 dh-apparmor
Standards-Version: 4.7.2
Homepage: http://www.anope.org/
Vcs-Browser: https://salsa.debian.org/dom/anope
Vcs-Git: https://salsa.debian.org/dom/anope.git
Rules-Requires-Root: binary-targets

Package: anope
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
Recommends: default-mta | mail-transport-agent
Breaks: ircd-hybrid (<< 8.2.23)
Description: IRC Services designed for flexibility and ease of use
 Anope offers various services to maintain your IRC network.
 .
 The following main services are included: NickServ, ChanServ, MemoServ,
 OperServ, BotServ, and HostServ.
 .
 The following IRC servers are supported:
 .
  * Bahamut 1.4.27 or later (including 1.8)
  * Charybdis 3.4 or later
  * ircd-hybrid 8.2.23 or later
  * InspIRCd 1.2 or later
  * ngIRCd 19.2 or later
  * Plexus 3 or later
  * Ratbox 2.0.6 or later
  * UnrealIRCd 3.2 or later
